﻿package{
	
	import flash.display.Sprite;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Stage;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.geom.Matrix;
	
	public class IntuitiveDrawer extends Sprite{
		
		var bg:BitmapData;
		var container:Bitmap;
		var line:Sprite;
		var lineCopy:Sprite;
		var lineStack:Array;
		var lineStack2:Array;
		var matrix:Matrix;
		
		public function IntuitiveDrawer():void{
			
			bg = new BitmapData(stage.stageWidth,stage.stageHeight,false,0x000000);
			container = new Bitmap(bg);
			addChild(container);
			
			stage.addEventListener(MouseEvent.MOUSE_DOWN,startDessine);
			stage.addEventListener(MouseEvent.MOUSE_MOVE,dessine);
			stage.addEventListener(MouseEvent.MOUSE_UP,stopDessine);
		
			}
			
		private function startDessine(e:MouseEvent):void{
			removeEventListener(Event.ENTER_FRAME,floodit);
			matrix = new Matrix();
			line = new Sprite();
			lineStack = new Array();
			lineStack2 = new Array();

			line.graphics.lineStyle(10,0xcccccc,0.5);
			line.graphics.moveTo(e.stageX,e.stageY);
			lineStack.push(new Array(e.stageX,e.stageY));
			lineStack2.push(new Array(e.stageX,e.stageY));

			}
		
		private function dessine(e:MouseEvent):void{
			if(line != null){
				//line.graphics.lineTo(e.stageX,e.stageY);
				lineStack.push(new Array(e.stageX,e.stageY));
				lineStack2.push(new Array(e.stageX,e.stageY));
				addChild(line);
				}
			}

		private function stopDessine(e:MouseEvent):void{
			if(line != null){
				removeChild(line);
				line = null;
				floodFill();
			}
		}
		
		private function floodFill():void{
			lineCopy = new Sprite();
			lineCopy.graphics.lineStyle(0.0001,buildColor(),0.6);
			lineCopy.graphics.beginFill(buildColor(),0.1)
			lineCopy.graphics.moveTo(lineStack[0][0],lineStack[0][1]);
			for(var i:uint=1;i<lineStack.length;i++){
				lineCopy.graphics.drawCircle(lineStack[i][0],lineStack[i][1],(mouseX+mouseY)/20);
				}
			addEventListener(Event.ENTER_FRAME,floodit);
			}
		private function floodit(e:Event):void{
			matrix.scale(0.88888888,1.09);
			matrix.translate(130, -480)
			matrix.rotate(20);
			bg.draw(lineCopy,matrix);
			}
			
		/*construction d'une valeur STRING pour une couleur aléatoire*/
		private function buildColor():uint{
			var R:uint = Math.round(1*255);
			var G:uint = Math.round(Math.random()*255);
			var B:uint = Math.round(Math.random()*255);
			var nbr:uint =  R << 20 | G << 8 | B;
			return nbr;
			trace (nbr)
			}
	}
	
}